// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/12AISS8AO4/samples/sbtest/oper_mode.c $
// $Rev: 51900 $
// $Date: 2022-10-20 10:02:06 -0500 (Thu, 20 Oct 2022) $

// 12AISS8AO4: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS8AO4_IOCTL_OPER_MODE,
			/* arg		*/	AISS8AO4_OPER_MODE_TARG,
			/* reg		*/	AISS8AO4_GSC_BCTLR,
			/* mask		*/	0x01000000,
			/* value	*/	0x00000000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS8AO4_IOCTL_OPER_MODE,
			/* arg		*/	AISS8AO4_OPER_MODE_INIT,
			/* reg		*/	AISS8AO4_GSC_BCTLR,
			/* mask		*/	0x01000000,
			/* value	*/	0x01000000
		},

		{ SERVICE_END_LIST }
	};

	int errs	= 0;

	errs	+= aiss8ao4_initialize(fd, -1, 0);

	errs	+= service_ioctl_set_reg_list(fd, list);
	errs	+= service_ioctl_reg_get_list(fd, list);

	errs	+= service_ioctl_set_reg_list(fd, list);
	errs	+= service_ioctl_reg_get_list(fd, list);

	errs	+= aiss8ao4_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _function_test(void)
{
	// This requires additional equipment to verify.
	return(0);
}



/******************************************************************************
*
*	Function:	oper_mode_tests
*
*	Purpose:
*
*		Perform a test of the IOCTL service AISS8AO4_IOCTL_OPER_MODE.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int oper_mode_tests(int fd)
{
	int	errs	= 0;

	gsc_label("AISS8AO4_IOCTL_OPER_MODE");
	errs	+= _service_test(fd);
	errs	+= _function_test();

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


